
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>SQL注入天书—ASP注入漏洞全接触 / iVAN</title>

    <meta name="description" content="SQL注入天书—ASP注入漏洞全接触 SQL注入天书-ASP注入漏洞全接触选择自 digituser 的 Blog 随着B/S模式应用开发的发展,使用这种模式编写应用程序的程序员也越来越多.但是由于这个行业的入门门槛不高,程序员的水平及经验也参差不齐,相当大一部分程序员在编写代码的时候,没有对用户输入数据的合法性进行判断,使应用程序存在安全隐患.用户可以提交一段数据库查询代码,根据程序返回的结果,获得某些他想得知的数据,这就是所谓的SQL Injection,即SQL注入. SQL注入是从正常的WWW端口访问,而且表面看起来跟一般的">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">SQL注入天书—ASP注入漏洞全接触</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>SQL注入天书—ASP注入漏洞全接触选择自 digituser 的 Blog <br />随着B/S模式应用开发的发展，使用这种模式编写应用程序的程序员也越来越多。但是由于这个行业的入门门槛不高，程序员的水平及经验也参差不齐，相当大一部分程序员在编写代码的时候，没有对用户输入数据的合法性进行判断，使应用程序存在安全隐患。用户可以提交一段数据库查询代码，根据程序返回的结果，获得某些他想得知的数据，这就是所谓的SQL Injection，即SQL注入。</p>
<p>SQL注入是从正常的WWW端口访问，而且表面看起来跟一般的Web页面访问没什么区别，所以目前市面的防火墙都不会对SQL注入发出警报，如果管理员没查看IIS日志的习惯，可能被入侵很长时间都不会发觉。</p>
<p>但是，SQL注入的手法相当灵活，在注入的时候会碰到很多意外的情况。能不能根据具体情况进行分析，构造巧妙的SQL语句，从而成功获取想要的数据，是高手与“菜鸟”的根本区别。</p>
<p>根据国情，国内的网站用ASP+Access或SQLServer的占70%以上，PHP+MySQ占L20%，其他的不足10%。在本文，我们从分入门、进阶至高级讲解一下ASP注入的方法及技巧，PHP注入的文章由NB联盟的另一位朋友zwell撰写，希望对安全工作者和程序员都有用处。了解ASP注入的朋友也请不要跳过入门篇，因为部分人对注入的基本判断方法还存在误区。大家准备好了吗？Let's Go...</p>
<p>入 门 篇</p>
<p>如果你以前没试过SQL注入的话，那么第一步先把IE菜单=&gt;工具=&gt;Internet选项=&gt;高级=&gt;显示友好 HTTP 错误信息前面的勾去掉。否则，不论服务器返回什么错误，IE都只显示为HTTP 500服务器错误，不能获得更多的提示信息。</p>
<p>第一节、SQL注入原理</p>
<p>以下我们从一个网站www.19cn.com开始（注：本文发表前已征得该站站长同意，大部分都是真实数据）。</p>
<p>在网站首页上，有名为“IE不能打开新窗口的多种解决方法”的链接，地址为：http://www.19cn.com/showdetail.asp?id=49，我们在这个地址后面加上单引号'，服务器会返回下面的错误提示：</p>
<p>Microsoft JET Database Engine 错误 '80040e14'</p>
<p>字符串的语法错误 在查询表达式 'ID=49'' 中。</p>
<p>/showdetail.asp，行8</p>
<p>从这个错误提示我们能看出下面几点：</p>
<p>1.网站使用的是Access数据库，通过JET引擎连接数据库，而不是通过ODBC。</p>
<p>2.程序没有判断客户端提交的数据是否符合程序要求。</p>
<p>3.该SQL语句所查询的表中有一名为ID的字段。</p>
<p>从上面的例子我们可以知道，SQL注入的原理，就是从客户端提交特殊的代码，从而收集程序及服务器的信息，从而获取你想到得到的资料。</p>
<p>第二节、判断能否进行SQL注入</p>
<p>看完第一节，有一些人会觉得：我也是经常这样测试能否注入的，这不是很简单吗？</p>
<p>其实，这并不是最好的方法，为什么呢？</p>
<p>首先，不一定每台服务器的IIS都返回具体错误提示给客户端，如果程序中加了cint(参数)之类语句的话，SQL注入是不会成功的，但服务器同样会报错，具体提示信息为处理 URL 时服务器上出错。请和系统管理员联络。</p>
<p>其次，部分对SQL注入有一点了解的程序员，认为只要把单引号过滤掉就安全了，这种情况不为少数，如果你用单引号测试，是测不到注入点的</p>
<p>那么，什么样的测试方法才是比较准确呢？答案如下：<br />① http://www.19cn.com/showdetail.asp?id=49</p>
<p>② http://www.19cn.com/showdetail.asp?id=49 and 1=1</p>
<p>③ http://www.19cn.com/showdetail.asp?id=49 and 1=2</p>
<p>这就是经典的1=1、1=2测试法了，怎么判断呢？看看上面三个网址返回的结果就知道了：</p>
<p>可以注入的表现：</p>
<p>① 正常显示（这是必然的，不然就是程序有错误了）</p>
<p>② 正常显示，内容基本与①相同</p>
<p>③ 提示BOF或EOF（程序没做任何判断时）、或提示找不到记录（判断了rs.eof时）、或显示内容为空（程序加了on error resume next）</p>
<p>不可以注入就比较容易判断了，①同样正常显示，②和③一般都会有程序定义的错误提示，或提示类型转换时出错。</p>
<p>　　当然，这只是传入参数是数字型的时候用的判断方法，实际应用的时候会有字符型和搜索型参数，我将在中级篇的“SQL注入一般步骤”再做分析。</p>
<p>第三节、判断数据库类型及注入方法</p>
<p>不同的数据库的函数、注入方法都是有差异的，所以在注入之前，我们还要判断一下数据库的类型。一般ASP最常搭配的数据库是Access和SQLServer，网上超过99%的网站都是其中之一。</p>
<p>怎么让程序告诉你它使用的什么数据库呢？来看看：</p>
<p>SQLServer有一些系统变量，如果服务器IIS提示没关闭，并且SQLServer返回错误提示的话，那可以直接从出错信息获取，方法如下：</p>
<p>http://www.19cn.com/showdetail.asp?id=49 and user&gt;0</p>
<p>这句语句很简单，但却包含了SQLServer特有注入方法的精髓，我自己也是在一次无意的测试中发现这种效率极高的猜解方法。让我看来看看它的含义：首先，前面的语句是正常的，重点在and user&gt;0，我们知道，user是SQLServer的一个内置变量，它的值是当前连接的用户名，类型为nvarchar。拿一个nvarchar的值跟int的数0比较，系统会先试图将nvarchar的值转成int型，当然，转的过程中肯定会出错，SQLServer的出错提示是：将nvarchar值 ”abc” 转换数据类型为 int 的列时发生语法错误，呵呵，abc正是变量user的值，这样，不废吹灰之力就拿到了数据库的用户名。在以后的篇幅里，大家会看到很多用这种方法的语句。</p>
<p>顺便说几句，众所周知，SQLServer的用户sa是个等同Adminstrators权限的角色，拿到了sa权限，几乎肯定可以拿到主机的Administrator了。上面的方法可以很方便的测试出是否是用sa登录，要注意的是：如果是sa登录，提示是将”dbo”转换成int的列发生错误，而不是”sa”。</p>
<p>如果服务器IIS不允许返回错误提示，那怎么判断数据库类型呢？我们可以从Access和SQLServer和区别入手，Access和SQLServer都有自己的系统表，比如存放数据库中所有对象的表，Access是在系统表[msysobjects]中，但在Web环境下读该表会提示“没有权限”，SQLServer是在表[sysobjects]中，在Web环境下可正常读取。</p>
<p>在确认可以注入的情况下，使用下面的语句：</p>
<p>http://www.19cn.com/showdetail.asp?id=49 and (select count(*) from sysobjects)&gt;0</p>
<p>http://www.19cn.com/showdetail.asp?id=49 and (select count(*) from msysobjects)&gt;0</p>
<p>如果数据库是SQLServer，那么第一个网址的页面与原页面http://www.19cn.com/showdetail.asp?id=49是大致相同的；而第二个网址，由于找不到表msysobjects，会提示出错，就算程序有容错处理，页面也与原页面完全不同。</p>
<p>如果数据库用的是Access，那么情况就有所不同，第一个网址的页面与原页面完全不同；第二个网址，则视乎数据库设置是否允许读该系统表，一般来说是不允许的，所以与原网址也是完全不同。大多数情况下，用第一个网址就可以得知系统所用的数据库类型，第二个网址只作为开启IIS错误提示时的验证。</p>
<p>进 阶 篇</p>
<p>在入门篇，我们学会了ＳＱＬ注入的判断方法，但真正要拿到网站的保密内容，是远远不够的。接下来，我们就继续学习如何从数据库中获取想要获得的内容，首先，我们先看看ＳＱＬ注入的一般步骤：</p>
<p>第一节、ＳＱＬ注入的一般步骤</p>
<p>首先，判断环境，寻找注入点，判断数据库类型，这在入门篇已经讲过了。</p>
<p>其次，根据注入参数类型，在脑海中重构SQL语句的原貌，按参数类型主要分为下面三种：</p>
<p>(A)  ID=49 这类注入的参数是数字型，SQL语句原貌大致如下：<br />Select * from 表名 where 字段=49<br />注入的参数为ID=49 And [查询条件]，即是生成语句：<br />Select * from 表名 where 字段=49 And [查询条件]</p>
<p>(B) Class=连续剧 这类注入的参数是字符型，SQL语句原貌大致概如下：<br />Select * from 表名 where 字段=’连续剧’ <br />注入的参数为Class=连续剧’ and [查询条件] and ‘’=’ ，即是生成语句：<br />Select * from 表名 where 字段=’连续剧’ and [查询条件] and ‘’=’’</p>
<p>(C) 搜索时没过滤参数的，如keyword=关键字，SQL语句原貌大致如下：<br />Select * from 表名 where 字段like ’%关键字%’ <br />注入的参数为keyword=’ and [查询条件] and ‘%25’=’， 即是生成语句：<br />Select * from 表名 where字段like ’%’ and [查询条件] and ‘%’=’%’</p>
<p>接着，将查询条件替换成SQL语句，猜解表名，例如：</p>
<p>ID=49 And (Select Count(*) from Admin)&gt;=0</p>
<p>如果页面就与ID=49的相同，说明附加条件成立，即表Admin存在，反之，即不存在（请牢记这种</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 03:29:40</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%96%b9%e6%b3%95/" title="方法">方法</a>, <a href="https://www.iamivan.net/tag/%e9%94%99%e8%af%af/" title="错误">错误</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93/" title="数据库">数据库</a>, <a href="https://www.iamivan.net/tag/%e6%8f%90%e7%a4%ba/" title="提示">提示</a>, <a href="https://www.iamivan.net/tag/%e8%af%ad%e5%8f%a5/" title="语句">语句</a>, <a href="https://www.iamivan.net/tag/sqlserver/" title="Sqlserver">Sqlserver</a>, <a href="https://www.iamivan.net/tag/%e6%95%b0%e6%8d%ae%e5%ba%93%e6%9f%a5%e8%af%a2%e5%88%a4%e6%96%ad/" title="数据库查询判断">数据库查询判断</a>, <a href="https://www.iamivan.net/tag/asp%e6%b3%a8%e5%85%a5/" title="ASP注入">ASP注入</a>, <a href="https://www.iamivan.net/tag/%e6%b3%a8%e5%85%a5%e6%95%b0%e6%8d%ae%e5%ba%93/" title="注入数据库">注入数据库</a>, <a href="https://www.iamivan.net/tag/%e6%b3%a8%e5%85%a5%e8%af%ad%e5%8f%a5/" title="注入语句">注入语句</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>SQL注入天书—ASP注入漏洞全接触的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0VK8p.html" rel="bookmark">SQL注入天书 - ASP注入漏洞全接触</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引 言 随着B/S模式应用开发的发展,使用这种模式编写应用程序的程序员也越来越多.但是由于这个行业的入门门槛不高,程序员的水平及经验也参差不齐,相当大一部分程序员在编写代码的时候,没有对用户输入数据的合法性进行判断,使应用程序存在安全隐患.用户可以提交一段数据库查询代码,根据程序返回的结果,获得某些他想得知的数据,这就是所谓的SQL Injection,即SQL注入. SQL注入是从正常的WWW端口访问,而且表面看起来跟一般的Web页面访问没什么区别,所以目前市面的防火墙都不会对SQL注入发出警			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/2MWR7qb.html" rel="bookmark">SQL注入天书之ASP注入漏洞全接触&lpar;1&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引 言 随着B/S模式应用开发的发展,使用这种模式编写应用程序的程序员也越来越多.但是由于这个行业的入门门槛不高,程序员的水平及经验也参差不齐,相当大一部分程序员在编写代码的时候,没有对用户输入数据的合法性进行判断,使应用程序存在安全隐患.用户可以提交一段数据库查询代码,根据程序返回的结果,获得某些他想得知的数据,这就是所谓的SQL Injection,即SQL注入. SQL注入是从正常的WWW端口访问,而且表面看起来跟一般的Web页面访问没什么区别,所以目前市面的防火墙都不会对SQL注入发出警			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7b2lorp.html" rel="bookmark">安全入门&colon;SQL注入漏洞全接触</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				安全 SQL注入是从正常的WWW端口访问,而且表面看起来跟一般的Web页面访问没什么区别,所以目前市面的防火墙都不会对SQL注入发出警报,如果管理员没查看IIS日志的习惯,可能被入侵很长时间都不会发觉. 但是,SQL注入的手法相当灵活,在注入的时候会碰到很多意外的情况.能不能根据具体情况进行分析,构造巧妙的SQL语句,从而成功获取想要的数据,是高手与&quot;菜鸟&quot;的根本区别. 根据国情,国内的网站用ASP+Access或SQLServer的占70%以上,PHP+MySQ占L20%,其他的不足			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjwEkNM.html" rel="bookmark">SQL注入漏洞全接触--入门篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				      随着B/S模式应用开发的发展,使用这种模式编写应用程序的程序员也越来越多.但是由于这个行业的入门门槛不高,程序员的水平及经验也参差不齐,相当大一部分程序员在编写代码的时候,没有对用户输入数据的合法性进行判断,使应用程序存在安全隐患.用户可以提交一段数据库查询代码,根据程序返回的结果,获得某些他想得知的数据,这就是所谓的SQL Injection,即SQL注入.     SQL注入是从正常的WWW端口访问,而且表面看起来跟一般的Web页面访问没什么区别,所以目前市面的防火墙都不会对SQ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MW77XqM.html" rel="bookmark">SQL注入漏洞全接触&mdash;&mdash;入门篇&lowbar;Mssql系列教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着B/S模式应用开发的发展,使用这种模式编写应用程序的程序员也越来越多.但是由于这个行业的入门门槛不高,程序员的水平及经验也参差不齐,相当大一部分程序员在编写代码的时候,没有对用户输入数据的合法性进行判断,使应用程序存在安全隐患.用户可以提交一段数据库查询代码,根据程序返回的结果,获得某些他想得知的数据,这就是所谓的SQL Injection,即SQL注入.  SQL注入是从正常的WWW端口访问,而且表面看起来跟一般的Web页面访问没什么区别,所以目前市面的防火墙都不会对SQL注入发出警报,如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0bo0QBM.html" rel="bookmark">ASP漏洞全接触-入门篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				随着B/S模式应用开发的发展,使用这种模式编写应用程序的程序员也越来越多.但是由于这个行业的入门门槛不高,程序员的水平及经验也参差不齐,相当大一部分程序员在编写代码的时候,没有对用户输入数据的合法性进行判断,使应用程序存在安全隐患.用户可以提交一段数据库查询代码,根据程序返回的结果,获得某些他想得知的数据,这就是所谓的SQL Injection,即SQL注入. SQL注入是从正常的WWW端口访问,而且表面看起来跟一般的Web页面访问没什么区别,所以目前市面的防火墙都不会对SQL注入发出警报,如果			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0oJxp.html" rel="bookmark">ASP漏洞全接触-入门篇&lowbar;安全相关</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   随着B/S模式应用开发的发展,使用这种模式编写应用程序的程序员也越来越多.但是由于这个行业的入门门槛不高,程序员的水平及经验也参差不齐,相当大一部分程序员在编写代码的时候,没有对用户输入数据的合法性进行判断,使应用程序存在安全隐患.用户可以提交一段数据库查询代码,根据程序返回的结果,获得某些他想得知的数据,这就是所谓的SQL Injection,即SQL注入. SQL注入是从正常的WWW端口访问,而且表面看起来跟一般的Web页面访问没什么区别,所以目前市面的防火墙都不会对SQL注入发出警报			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/xp8qG9z.html" rel="bookmark">SQL注入天书之ASP注入漏洞全接触&lpar;3&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				高级篇 看完入门篇和进阶篇后,稍加练习,破解一般的网站是没问题了.但如果碰到表名列名猜不到,或程序作者过滤了一些特殊字符,怎么提高注入的成功率?怎么样提高猜解效率?请大家接着往下看高级篇. 第一节.利用系统表注入SQLServer数据库 SQL Server是一个功能强大的数据库系统,与操作系统也有紧密的联系,这给开发者带来了很大的方便,但另一方面,也为注入者提供了一个跳板,我们先来看看几个具体的例子: ① http://Site/url.asp?id=1;exec master..xp_cmd			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MYkZBBz.html" rel="bookmark">SQL注入天书之ASP注入漏洞全接触&lpar;2&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				进阶篇 在入门篇,我们学会了SQL注入的判断方法,但真正要拿到网站的保密内容,是远远不够的.接下来,我们就继续学习如何从数据库中获取想要获得的内容,首先,我们先看看SQL注入的一般步骤: 第一节.SQL注入的一般步骤 首先,判断环境,寻找注入点,判断数据库类型,这在入门篇已经讲过了. 其次,根据注入参数类型,在脑海中重构SQL语句的原貌,按参数类型主要分为下面三种: (A) ID=49 这类注入的参数是数字型,SQL语句原貌大致如下: Select * from 表名 where 字段=49 注			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1Mv5N1b.html" rel="bookmark" class="title">加大力度保卫自己网站的胜利果实</a>
					<div>
						网站需要保卫么?推广还来不及呢,哪能拒客于门外.不过网站的确需要保护,不然-- 1.防网页框架 这年头,流氓都没人管,或者说,有后台的流氓都没人管.于是各种各样形形色色的流氓遍地开花.借网摘之名,收流 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz41YJb.html" rel="bookmark" class="title">UI设计&colon;触摸优先设计、响应式设计、移动优先设计</a>
					<div>
						文章描述:UI应遵循的三大网站设计原则. 触摸优先设计.响应式设计.移动优先设计是UI设计师设计网站应遵循的三大原则,以使网站最大范围地适应各种设备.外文&lt;Designing The Well- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNAe7b.html" rel="bookmark" class="title">php foreach 参数强制类型转换的问题</a>
					<div>
						所以,为了防止这样的信息出现,我使用foreach的时候,都会把参数进行强制类型转换,形势如下: foreach((array)$arr as $key =&gt; $value); 这样做一直相安无 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKRDNp.html" rel="bookmark" class="title">企业级应用框架：三层架构之解耦</a>
					<div>
						前言 前段时间朋友拿了个网站给我,让我帮忙添加几个小功能,我爽快的答应了,但是当我打开源码,我瞬间就奔溃了,整个项目连最基本的三层框架也没有搭建,仅仅是封装了一个sqlhelp作为数据库的操作接口,项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGjJjnp.html" rel="bookmark" class="title">走近Flex组件系列&lpar;三&rpar;：按扭组件</a>
					<div>
						走近Flex组件系列(三):按扭组件(Button,CheckBox,LinkBar,LinkButton,PopUpButton,RadioButton,ToggleButtonBar) 本文主要介 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAaE33M.html" rel="bookmark" class="title">tomcat的类加载及配置文件</a>
					<div>
						tomcat服务器是一种Servlet/jsp容器,更实质性的说是Servlet容器,因为jsp最终还是被编译成servlet来执行的 1. tomcat web.xml (1)&lt;welcome ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze49wAp.html" rel="bookmark" class="title">项目所得&colon;一个非典型性改动带来的思考&lpar;三&rpar; 之项目设计</a>
					<div>
						上篇 中描述了针对第一个问题的思考, 在写的过程中几个关键词逐渐引起了我的注意, 本篇就让它们登台吧 , 它们是: 现在项目的套路及缺点, 数据库实现业务逻辑, 程序设计的美. 先看第一个, 即现在项 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlVd8b.html" rel="bookmark" class="title">PS鼠绘梅花背景图案的古装美女</a>
					<div>
						教程作者展示了一幅较为忧伤的古典插画.不断飘落的花瓣增加了女孩忧伤的心思,散乱的头发及忧郁的眼神,告诉我们她真正期盼他的回归...作者整个鼠绘的过程都描述的非常详细,过程图也非常丰富,喜欢鼠绘,尤其是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBmWOz.html" rel="bookmark" class="title">如何取消搜狗浏览器为默认浏览器？</a>
					<div>
						  我们可以通过设置其他自己喜欢的浏览器来代替搜狗为默认浏览器,首选我们打款360.点击右侧更多按钮 点击[默认软件] 找到浏览器一栏,在这里可以选择自己喜欢的浏览器来代替搜狗浏览器哦. 为了防止搜狗 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmGEZ7b.html" rel="bookmark" class="title">Photoshop教你给MM的衣服换个颜色</a>
					<div>
						  拍摄完成了,现在来为MM的裙子换个颜色吧. 原图 一般在提到换颜色时大家最快想到的一定是使用色相/饱和度或者替换颜色命令,这两种方法确实是很快捷,但是在改变颜色后图像的层次会发生改变.我们今天就来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkGjLjp.html" rel="bookmark" class="title">nmm载入MOD无效怎么办</a>
					<div>
						  nmm载入MOD无效如何操作?nmm载入MOD没反应解决办法: 点击软件里的mod,然后从左侧的蓝色添加按钮加入mod,双击安装,左侧的plugins就会显示安装好的esp文件,有勾说明已经加载, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3o5V0b.html" rel="bookmark" class="title">CCL 2017最佳论文公布，看全国计算语言学前沿研究</a>
					<div>
						10 月 14 日.15 日,由中国中文信息学会(CIPS)举办的第十六届全国计算语言学会议(CCL 2017)暨第五届自然标注大数据的自然语言处理国际学术研讨会(NLP -NABD 2017)于江苏 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamBy2b.html" rel="bookmark" class="title">大牛讲堂 &vert; 山世光博士：自动驾驶系统中的目标检测技术</a>
					<div>
						雷锋网按:作者山世光博士,中科院计算所研究员.博导,主要从事计算机视觉.模式识别.机器学习等相关研究工作.迄今已发表CCF A类论文50余篇,全部论文被Google Scholar引用9000余次.现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWON4p.html" rel="bookmark" class="title">android-怎么编译64位安卓c程序应该用哪个交叉编译器</a>
					<div>
						问题描述 怎么编译64位安卓c程序应该用哪个交叉编译器 armv7的指令集.用arm-linux-gcc编译的小程序无法运行 解决方案 64位是x86-64还是arm64,确定之后去Google An ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YZgkM.html" rel="bookmark" class="title">nginx&plus;nagios在ubuntu下搭建过程全程指导</a>
					<div>
						今天终于把nginx+nagios在我自己的ubuntu机器下搭建起来,特此写一个教程,有2个目的,1作为备忘录留为己用,2作为新手教程指导.  1.安装nginx,在ubuntu下apt-cache ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7JJ0z.html" rel="bookmark" class="title">extjs4-ext js 4&period;2&period;1 官网例子的多Tab效果是如何实现的？</a>
					<div>
						问题描述 ext js 4.2.1 官网例子的多Tab效果是如何实现的? 链接:官网地址 上图为链接页面部分截图,看一般的实现只有一个tab panel(点击结构树,内容在tab中显示),但是这里感觉 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXqWjvz.html" rel="bookmark" class="title">易语言-推荐比较适合我的编程语言</a>
					<div>
						问题描述 推荐比较适合我的编程语言 我想在业余时间学点编程,可是又不知道学什么编程语言,我主要用来编写软件,或者外挂之类的,谁能给我推荐个,最好是简单点的. 解决方案 推荐你使用易语言.非常适合你这种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBZr1b.html" rel="bookmark" class="title">javamail发送邮件异常</a>
					<div>
						问题描述 javamail发送邮件异常 javax.mail.AuthenticationFailedException: 535 5.7.8 Error: authentication failed ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRLJ5b.html" rel="bookmark" class="title">Xpath in JavaScript &lpar;第一部分&rpar;</a>
					<div>
						       Xpath现在很少被我们使用,因为JSON现在很盛行.可是在XML做为数据交换格式的年代,Xpath在我们随机访问大的xml文档结构的时候扮演着非常重要的位置.也许大家现在很多没有注意到 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL73AaM.html" rel="bookmark" class="title">MVC新手自学 请教两个问题</a>
					<div>
						问题描述 1.Html.TextBox(&quot;name&quot;)可以通过控制器里ViewData[&quot;name&quot;]赋值为什么Html.TextBoxFor不行?2.假如要从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8A7PNz.html" rel="bookmark" class="title">网易魔兽尚未通过文化部内容审批</a>
					<div>
						6月30日,据搜狐IT了解,在新闻出版总署的审批迟迟未有通过之时,网易魔兽也尚未通过文化部的内容审查. 根据文化部相关知情人士披露,提交至文化部进行审批的进口网络游戏一旦通过审查,将会及时在文化部官方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLg7JLM.html" rel="bookmark" class="title">合并datatable字段重复的值</a>
					<div>
						问题描述 一个datatable楼层时间姓名一层上午小李.小张一层下午小王二层上午小田三层上午小何.小林三层下午小曾.小丁.小胡四层上午小廖四层下午小邓.小马五层下午小苏合并后变成:楼层上午下午一层小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgPaaM.html" rel="bookmark" class="title">《算法技术手册》一1&period;3&period;5 融会贯通</a>
					<div>
						1.3.5 融会贯通 通常,解决某一类问题的算法和解决某一个特定问题的算法是大致相通的.Voronoi图(Preparata and Shamos,1993)是这样一个几何结构--它可以将平面上的点集 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pX0aOlp.html" rel="bookmark" class="title">QQ音乐与网易云音乐开始掐架&comma;核心是版权</a>
					<div>
						当新兴的力量开始出现的时候,传统的&quot;法老&quot;们总是会想尽一切办法将这股新生的力量处死,在新旧事物出现交替的时候,博弈总是那么明显. 日前,QQ音乐率先针对网易云音乐的侵权进行起诉,法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxEJEBp.html" rel="bookmark" class="title">A31s的OV5640摄像头图像偏绿问题</a>
					<div>
						问题描述 A31s的OV5640摄像头图像偏绿问题 拜托各位给看看,谢谢. 解决方案 看下数据填充RGB有问题没,看摄像头支持MJPEG格式不					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boqJxDp.html" rel="bookmark" class="title">ABI Research发布vEPC厂商大玩家</a>
					<div>
						ABI Research预测,到2019年vEPC的支出将超过物理网络功能的支出,到2021年将达到80亿美元. 根据ABI Research发布的Mobile Packet Core VNFs an ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zenKXwb.html" rel="bookmark" class="title">发布Discuz&excl; X2&period;5正式版以及Discuz&excl; 云平台升级版</a>
					<div>
						[TechWeb报道]4月7日消息,第七届中国互联网站长年会今日召开,康盛公司总裁戴志康.副总裁袁兆江以及落伍者创始人董勤锋联合发布了Discuz! X2.5正式版以及Discuz! 云平台升级版.戴 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx24ePz.html" rel="bookmark" class="title">JS实现从顶部下拉显示的带动画QQ客服特效代码&lowbar;javascript技巧</a>
					<div>
						本文实例讲述了JS实现从顶部下拉显示的带动画QQ客服特效代码.分享给大家供大家参考,具体如下: 这是一款动画版QQ在线客服代码,从网页顶部下拉出来的QQ客服,下滑结束后有弹性缓冲效果.在世界地图的映衬 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWDG1p.html" rel="bookmark" class="title">龙文的多元化：在一对一教学点叠加英语、职业培训</a>
					<div>
						对于龙文教育来说,推出剑桥少儿英语业务只是多元化探索的第一步,接下来在原有渠道(教学点),龙文会叠加英语.职业培训和才艺教育等.龙文投资方.信中利董事长汪潮涌接受&lt;中国经营报&gt;采访时提到一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXqLBz.html" rel="bookmark" class="title">《游戏开发物理学（第2版）》一1&period;1　牛顿运动定律</a>
					<div>
						1.1 牛顿运动定律 17世纪后期(1687年左右),艾萨克·牛顿爵士发表了他的力学哲学著作--&lt;自然哲学的数学原理&gt;(Philosophiae Naturalis Principia M ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
